<template>
  <div id="q-app">
    
    <router-view />

    <log-in id="loginLib" ref="loginLib"
        name="Gen" 
        description="Development Environment Generator"
        fb-id="231073027965732"
        ggle-id="880392058619-492rbamvs7tp7l3kantp8ei5s74bilv4.apps.googleusercontent.com"
        :login-flag="loginFlag"
        @login-flag-changed="loginFlag = $event.detail.value;"
        @after="getbackFrLogin">
    </log-in>

  </div>
</template>

<script>

import '@shifang2013/log-in/log-in.js';
import async from 'async';

require('dotenv').config();

export default {
  name: 'App',

  data () {
    return {

      // Value meaning
      //  0 = no login 
      //  1 = login
      //  2 = user tap account icon with no login
      loginFlag: 0,

    }
  },

  watch: {

    loginFlag: function (val, oldVal) {
      this.$store.commit('gen/updateLoginFlag', val);
    }  
  },

  methods: {

    getbackFrLogin(loginData) {

      var that = this;

      //===================================
      // Login user info.
      //console.log("Login user info. ", loginData.detail.value);

      async.series([

          function(callback) {

              //===================================
              // after success login
              //  push this user info. into server
              that.$axios({
                url: 'gnl.gnl.doctype.login.login.tokenSignin',
                method: 'post',
                baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
                data: {
                  "email" : loginData.detail.value.email
                  , "token": loginData.detail.value.token
                  , "social": loginData.detail.value.social
                  , "user_id": loginData.detail.value.user_id
                  , "app_name": 'gen'           // should same to .../frappe-bench/sites/loginCfg.json
                },
              })
              .then(function (response) {
                //console.log('tokenSignin response ', response);
                switch (response.status) {
                    case 200:
                        if (response.data == "{}") {
                            console.log('not data, empty  '); 
                            // empty return
                        } else {
                            //console.log('this record content is ', response.data);
                            var ret = JSON.parse(response.data.message);
                            //console.log('this record content is 1 ', ret);

                            if (ret.status == "Done") {
                                //callback("Creating Success ");
                                //console.log('Done of Server side Login');

                                // save login user info.
                                that.$store.commit('gen/updateUserInfo', loginData.detail.value);

                                // jump to last protected page after login. 
                                that.$router.push({
                                  path: loginLib.preRoute
                                }, () => {});

                                callback(null, '1st serial function');

                            } else if (ret.status == "Err") {
                                //callback("Creating Success ");
                                console.log('Err of Server side Login');
                            } else if (ret.status == "InAuth") {
                                //callback("Creating Success ");
                                console.log('InAuth of Server side Login');
                            } else if (ret.status == "DuplicateEntryError") {
                                //callback("This item already existed", ret.user);
                            } else 
                                console.log('ret.status: A err. of null of above');
                        }
                    break;
                    case 403:
                        //callback("Please Login before create item ");
                    break;
                    case 409:
                        //callback("This item already existed");
                    break;
                    default:
                        //console.log("Misc. Err. in creating ", xhr);
                        //callback("Misc. Err. in creating ");
                }
              })
              .catch(function (error) {
                console.log("** An error occurred during the getbackFrLogin()", error);
              });

          },

          function(callback) {

              // create this user workspace at backend
              that.$axios({
                url: 'gnl.gnl.doctype.devenv.devenv.newWorkspace',
                method: 'post',
                baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
                data: {
                  "user_id": loginData.detail.value.user_id
                },
                headers: { SfAuth: loginData.detail.value.token },
              })
              .then(function (response) {

                //console.log('tokenSignin response ', response);
                switch (response.status) {
                    case 200:
                        if (response.data == "{}") {
                            console.log('creating workspace: empty response data'); 
                        } else {
                            var ret = JSON.parse(response.data.message);

                            if (ret.status == "Done") {

                            } else if (ret.status == "InAuth") {
                                console.log(ret.des);
                            } else if (ret.status == "InData") {
                                console.log(ret.des);
                            } else 
                                console.log('creating workspace: A err. of null of above'); 
                        }
                    break;
                    case 403:
                        //callback("Please Login before create item ");
                    break;
                    case 409:
                        //callback("This item already existed");
                    break;
                    default:
                        //console.log("Misc. Err. in creating ", xhr);
                        //callback("Misc. Err. in creating ");
                }
                callback(null, '2nd serial function');
              })
              .catch(function (err) {
                callback(err, "** An error occurred during Creating this user workspace at backend");
              });

          }
      ],
      // optional callback
      function(err, results) {
          // results is now equal to ['1st serial function', '2nd serial function']
          if (err != undefined) {
            console.log('Err. during async() ', err); 
          }
      });

    }

  },
}
</script>
